export {LogMemory}

class LogMemory {
	
	currentBytes = 0
	MAX_BYTES = 5000000
	currentThrottle = 0

	
	constructor(){
		window.sessionStorage.setItem("log", "")
		this.currentBytes += 6
	}
	
	LogSendPing(timestamp,messagenum){
		let entry = ["s", timestamp, messagenum, this.throttle].join(" ") + '\n'
		if (this.currentBytes + entry.length < this.MAX_BYTES) {
			window.sessionStorage.log += entry
			this.currentBytes += entry.length*2
		}
	}
	
	LogRecievePing(timestamp,messagenum,rtt){
		let entry = ["r", timestamp, messagenum, this.throttle, rtt].join(" ") + '\n'
		if (this.currentBytes + entry.length*2 < this.MAX_BYTES) {
			window.sessionStorage.log += entry
			this.currentBytes += entry.length*2
		}
	}
	
	SetThrottle(throttle){
		this.throttle = throttle
	}

	DownloadLog(){
		let downloadLink = document.getElementById("downloadlink")
		let logfile = new File([window.sessionStorage.log],"log.txt",{type: "text/plain"})
		downloadLink.href = URL.createObjectURL(logfile)
		downloadLink.click()
		URL.revokeObjectURL(logfile)
	}
	
}
