export {Ping,PING_INTERVAL}

const PING_INTERVAL = 350

class Ping{
	
	constructor (sendChannel,carkey,saveLog=undefined){
		this.sendCh = sendChannel
		this.carkey = carkey
		this.messageNum = 0
		if (saveLog){
			this.saveLog = saveLog
		}
	}
	
	SendPing(){
		let currentTime = new Date().valueOf()
		if (this.carkey == null){
			this.sendCh.send("- " + "ping " + this.messageNum + " " + currentTime)
		} else {			
			this.sendCh.send(this.carkey + " " + "ping " + this.messageNum + " " + currentTime)
		}
		if (this.saveLog) {this.saveLog.LogSendPing(currentTime,this.messageNum)}
		
		this.messageNum += 1
	}
	
	MeasureLatency(message){
		let newTime = new Date().valueOf()
		let parts = message.split(" ")
		let oldTime = parseInt(parts[2])
		if (isNaN(oldTime)){
			console.log("ERROR: Message does not contain timestamp") 
			return
		}
		let diff = newTime - oldTime
		document.getElementById("rtt").children[0].innerText = diff
		if (this.saveLog) {this.saveLog.LogRecievePing(newTime,parts[1],diff)}

	}
	
}
